/* ե벻ץΥץȥ (aiff version)
 * shige
 * 10/28 2001
 * aiffnormal.c
 *
 * $Id: aiffnormal.c,v 1.2 2001-11-02 11:16:57+09 shige Exp $
 */
/* gcc -I. -o aiffnormal aiffnormal.c aiffio.c fileio.c dist/ToFromIEEE.c -lm
 */
#include <stdio.h>
#include <stdlib.h>
#include "aiffio.h"
#include "ToFromIEEE.h"
#ifndef Max
# define Max(a,b)  (((a)>(b))?(a):(b))
#endif
#ifndef Abs
# define Abs(a)  Max((a),-(a))
#endif

int getarg(int argc,char **argv,double *vol,FILE **infile,FILE **outfile,
	   int *verbose,int *info);
void usage(void);

int main(int argc,char *argv[])
{
    AIFFdata ad;
    FILE *infile,*outfile;
    int j,info,verbose;
    int totalblocks;
    short int x;
    char c;
    double vol,times,maxlevel;
    int max=0,ret;
#ifdef DEBUG
    int minv=0,maxv=0;
#endif

    if((ret=getarg(argc,argv,&vol,&infile,&outfile,&verbose,&info))<0)
      return -ret;
    if((ret=getAIFFheader(infile,&ad))<0){ 
        fprintf(stderr,"get header error.\n");
        return -ret;
    }
    fseek(infile,ad.hlen,SEEK_SET);
    totalblocks=ad.flames*ad.channel;
    if(ad.bitpersmpl==8){ /* 8bit */
        for(j=1;j<=totalblocks;j++){
            c=fgetc(infile);
            if(Abs(c-AIFFPOS8bit)>max) max=Abs(c-AIFFPOS8bit);
#ifdef DEBUG
	    if(c-AIFFPOS8bit>maxv) maxv=c-AIFFPOS8bit;
	    else if(c-AIFFPOS8bit<minv) minv=c-AIFFPOS8bit;
#endif
        }
#ifdef DEBUG
	fprintf(stderr,"(max,maxv,minv)=(%d,%d,%d)\n",max,maxv,minv);
#endif
    }
    else if(ad.bitpersmpl==16){ /* 16bit */
        for(j=1;j<=totalblocks;j++){
            read2bytetoi(infile,&x); 
            if(Abs(x-AIFFPOS16bit)>max) max=Abs(x-AIFFPOS16bit);
        }
    }
    else{
	fprintf(stderr,"This program support only 8/16 bit/sample data.\n");
	return Exit_chAIFFheader;
    }
    if(ad.bitpersmpl==8) maxlevel=(double)max/AIFFSCALE8bit;
    else maxlevel=(double)max/AIFFSCALE16bit;
    if(maxlevel<=0.0) times=0.0;
    else times=vol/maxlevel;
    if(info){
	if(!verbose) fprintf(outfile,"%f %f\n",maxlevel,times);
	else fprintf(outfile,"level = %f ,  times = %f\n",maxlevel,times);
	return No_err;
    }
    putallAIFFheader(outfile,&ad,1);
    fseek(infile,ad.hlen,SEEK_SET);
    if(ad.bitpersmpl==8){ /* 8bit */
        for(j=1;j<=totalblocks;j++){
            c=fgetc(infile);
            c=(c-AIFFPOS8bit)*times+AIFFPOS8bit;
            fputc(c,outfile);
        }
	if(ad.datalen%2) fputc('\0',outfile);
    }
    else{ /* 16bit */
        for(j=1;j<=totalblocks;j++){
            read2bytetoi(infile,&x); 
            x=(x-AIFFPOS16bit)*times+AIFFPOS16bit;
            writeito2byte(outfile,x);
        }
    }
    return No_err;
}

int getarg(int argc,char **argv,double *vol,FILE **infile,FILE **outfile,
	   int *verbose,int *info)
{
    char *fname;

    *verbose=0;
    *info=0;
    *outfile=NULL;
    while(--argc>0){
	if(**(++argv)=='-'){
	    if(*(++*argv)=='v') *verbose=1;
	    else if(**argv=='q') *verbose=0;
	    else if(**argv=='i') *info=1;
	    else if(**argv=='o'){
		if(*outfile!=NULL){ usage(); return Err_param; }
		if(*(++*argv)=='\0'){
		    if(--argc<=0){ usage(); return Err_param; }
		    else argv++;
		}
		fname=*argv;
		if(!strcmp(fname,"-")) *outfile=stdout;
		else if((*outfile=fopen(fname,"w"))==NULL){
		    fprintf(stderr,"File [%s] open error.\n",fname);
		    return Err_fopen;
		}
	    }
	    else if(**argv=='h' || **argv=='H' || **argv=='?'){
		usage(); return Err_help;
	    }
	    else{ usage(); return Err_param; }
	}
	else break;
    }
    if(argc!=2){ usage(); return Err_param; }
    if(*outfile==NULL) *outfile=stdout;
    if((*vol=atof(*argv))<0.0 || *vol>1.0){ usage(); return Err_param; }
    fname=*(++argv);
    /* if(!strcmp(fname,"-")) *infile=stdin; */
    if(!strcmp(fname,"-")){ usage(); return Err_param; }
    else if((*infile=fopen(fname,"r"))==NULL){
	fprintf(stderr,"File [%s] open error.\n",fname);
	return Err_fopen;
    }
    return No_err;
}

void usage(void)
{
    char *mess[]={
	"Usage: aiffnormal (-o [outfile]) (-i) [vol] [infile]",
	"       aiffnormal -h",
	" -o [outfile] : ե [outfile] ˽ (default: ɸ)",
	/* " -v : Ĺ", */
	/* " -q : Ĺ", */
	" -i : ߤΥ٥Ȥܤˤ뤫ɽ (Ϥʤ)",
	" [vol] : ̥٥ (0.0~1.0)",
	" [infile] : βե",
	"Ex. aiffnormal 0.8 a.aif > a2.aif",
	" 1) [file] κ粻̤Ĵ١줬 (粻̥٥)[vol] ",
	"    ʤ褦Ѵ롣",
	" 2) -i ꤷȤϲեν񤭽ФϤʤ",
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++) fprintf(stderr,"%s\n",mess[j]);
}

