/* ե벻ץΥץȥ (wav version)
 * shige
 * 10/28 2001
 * wavnormal.c
 *
 * $Id: wavnormal.c,v 1.2 2001-11-02 11:19:14+09 shige Exp $
 */
/* gcc -I. -o wavnormal wavnormal.c wavio.c fileio.c
 */
#include <stdio.h>
#include <stdlib.h>
#include "wavio.h"
#ifndef Max
# define Max(a,b)  (((a)>(b))?(a):(b))
#endif
#ifndef Abs
# define Abs(a)  Max((a),-(a))
#endif

int getarg(int argc,char **argv,double *vol,FILE **infile,FILE **outfile,
	   int *verbose, int *info);
void usage(void);

int main(int argc,char *argv[])
{
    WAVdata wd;
    FILE *infile,*outfile;
    int j,info,verbose;
    int totalblocks;
    short int x;
    unsigned char c;
    double vol,times,maxlevel;
    int max=0,ret;
#ifdef DEBUG
    int maxv=0,minv=0;
#endif

    if((ret=getarg(argc,argv,&vol,&infile,&outfile,&verbose,&info))<0)
      return -ret;
    if((ret=getWAVheader(infile,&wd))<0){ 
        fprintf(stderr,"get header error.\n");
        return -ret;
    }
    if(wd.fmcode!=1){
        fprintf(stderr,"This is not linear PCM data. (%d)\n",wd.fmcode);
        return Exit_chWAVheader;
    }
    fseek(infile,wd.hlen,SEEK_SET);
    totalblocks=(wd.datalen/wd.blocksize)*wd.channel;
    if(wd.bitpersmpl==8){ /* 8bit */
        for(j=1;j<=totalblocks;j++){
            c=fgetc(infile);
            if(Abs(c-WAVPOS8bit)>max) max=Abs(c-WAVPOS8bit);
#ifdef DEBUG
	    if(c-WAVPOS8bit>maxv) maxv=c-WAVPOS8bit;
	    else if(c-WAVPOS8bit<minv) minv=c-WAVPOS8bit;
#endif
        }
#ifdef DEBUG
	fprintf(stderr,"(max,minv,maxv)=(%d,%d,%d)\n",max,minv,maxv);
#endif
    }
    else{ /* 16bit */
        for(j=1;j<=totalblocks;j++){
            read2bytetolittlei(infile,&x); 
            if(Abs(x-WAVPOS16bit)>max) max=Abs(x-WAVPOS16bit);
        }
    }
    if(wd.bitpersmpl==8) maxlevel=(double)max/WAVSCALE8bit;
    else maxlevel=(double)max/WAVSCALE16bit;
    if(maxlevel<=0.0) times=0.0;
    else times=vol/maxlevel;
    if(info){
	if(!verbose) fprintf(outfile,"%f %f\n",maxlevel,times);
	else fprintf(outfile,"level = %f ,  times = %f\n",maxlevel,times);
	return No_err;
    }
    putallWAVheader(outfile,&wd,1);
    fseek(infile,wd.hlen,SEEK_SET);
    if(wd.bitpersmpl==8){ /* 8bit */
        for(j=1;j<=totalblocks;j++){
            c=fgetc(infile);
            c=(c-WAVPOS8bit)*times+WAVPOS8bit;
            fputc(c,outfile);
        }
	if(wd.datalen%2) fputc('\0',outfile);
    }
    else{ /* 16bit */
        for(j=1;j<=totalblocks;j++){
            read2bytetolittlei(infile,&x); 
            x=(x-WAVPOS16bit)*times+WAVPOS16bit;
            writelittleito2byte(outfile,x);
        }
    }
    return No_err;
}

int getarg(int argc,char **argv,double *vol,FILE **infile,FILE **outfile,
	   int *verbose,int *info)
{
    char *fname;

    *verbose=0;
    *info=0;
    *outfile=NULL;
    while(--argc>0){
	if(**(++argv)=='-'){
	    if(*(++*argv)=='v') *verbose=1;
	    else if(**argv=='q') *verbose=0;
	    else if(**argv=='i') *info=1;
	    else if(**argv=='o'){
		if(*outfile!=NULL){ usage(); return Err_param; }
		if(*(++*argv)=='\0'){
		    if(--argc<=0){ usage(); return Err_param; }
		    else argv++;
		}
		fname=*argv;
		if(!strcmp(fname,"-")) *outfile=stdout;
		else if((*outfile=fopen(fname,"w"))==NULL){
		    fprintf(stderr,"File [%s] open error.\n",fname);
		    return Err_fopen;
		}
	    }
	    else if(**argv=='h' || **argv=='H' || **argv=='?'){
		usage(); return Err_help;
	    }
	    else{ usage(); return Err_param; }
	}
	else break;
    }
    if(argc!=2){ usage(); return Err_param; }
    if(*outfile==NULL) *outfile=stdout;
    if((*vol=atof(*argv))<0.0 || *vol>1.0){ usage(); return Err_param; }
    fname=*(++argv);
    /* if(!strcmp(fname,"-")) *infile=stdin; */
    if(!strcmp(fname,"-")){ usage(); return Err_param; }
    else if((*infile=fopen(fname,"r"))==NULL){
	fprintf(stderr,"File [%s] open error.\n",fname);
	return Err_fopen;
    }
    return No_err;
}

void usage(void)
{
    char *mess[]={
	"Usage: wavnormal (-o [outfile]) (-i) [vol] [infile]",
	"       wavnormal -h",
	" -o [outfile] : ե [outfile] ˽ (default: ɸ)",
	/* " -v : Ĺ", */
	/* " -q : Ĺ", */
	" -i : ߤΥ٥Ȥܤˤ뤫ɽ (Ϥʤ)",
	" [vol] : ̥٥ (0.0~1.0)",
	" [infile] : βե",
	"Ex. wavnormal 0.8 a.wav > a2.wav",
	" 1) [file] κ粻̤Ĵ١줬 (粻̥٥)[vol] ",
	"    ʤ褦Ѵ롣",
	" 2) -i ꤷȤϲեν񤭽ФϤʤ",
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++) fprintf(stderr,"%s\n",mess[j]);
}

